#include "control_unit.h"

void control_unit::process_next_state() {
 sc_uint<6> op;
 op=opcode.read();

 if(rst.read()) 
  stato.write(FETCH);
 else 
 switch(stato.read()) {
  case FETCH : stato.write(DECODE);
        break;
  case DECODE: switch(op) {
        case 0 : stato.write(EX_R);
                break;
        case 1 : stato.write(EX_IMM);
                break;
        case 16 : stato.write(EX_BRANCH);
                break;
        case 32 : stato.write(EX_LW);
                break;
        case 40 : stato.write(EX_SW);
                break;
        default: ; }
        break;
  case EX_R: stato.write(WB_R);
        break;
  case EX_IMM: stato.write(WB_IMM);
        break;
  case EX_LW : stato.write(MM_LW);
        break;
  case MM_LW : stato.write(WB_LW);
        break;
  case WB_LW : stato.write(FETCH);
       break;
  case EX_SW : stato.write(MM_SW);
        break;
  default: stato.write(FETCH);
  }
 cout << "stato: " << stato.read() << endl;
}

void control_unit::process_genera_output() {

 switch(stato.read()) {
  case FETCH :    MemRead.write(true);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(false);
        RegWrite.write(false);
        
    state.write(1);
        break;
  case DECODE:    MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(true);
        AluWrite.write(false);
        RegWrite.write(false);
        
    state.write(2);
        break;
  case EX_R:    MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(true);
        RegWrite.write(false);
        
    state.write(3);
        break;
  case WB_R:   MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(false);
        RegWrite.write(true);
        
    state.write(4);
        break;
 case EX_IMM:    MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(true);
        RegWrite.write(false);
        
    state.write(5);
        break;
  case WB_IMM:   MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(false);
        RegWrite.write(true);
        
    state.write(6);
        break;
  case EX_BRANCH: MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(true);
        RegWrite.write(false);
        
    state.write(7);
        break;
  case EX_LW:    MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(true);
        RegWrite.write(false);
        
    state.write(8);
        break;
  case MM_LW:    MemRead.write(true);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(false);
        RegWrite.write(false);
        
    state.write(9);
        break;
  case WB_LW:    MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(false);
        RegWrite.write(true);
        
    state.write(10);
        break;
 case EX_SW:    MemRead.write(false);
        MemWrite.write(false);
        AWrite.write(false);
        AluWrite.write(true);
        RegWrite.write(false);
        
    state.write(11);
        break;
  case MM_SW:    MemRead.write(false);
        MemWrite.write(true);
        AWrite.write(false);
        AluWrite.write(false);
        RegWrite.write(false);
        
    state.write(12);
        break;
  default: ;
  }
 
}
