#include "dlx_seq_stati.h"

void dlx_seq_stati::proc_next_state()
{ 
 sc_uint<5> ra,rb,rc;
 sc_lv<32> tIR;
 
 stato.write(FETCH);
 wait();
 while(1) {
   switch(stato.read()) {
     case FETCH : stato.write(DECODE);
        break;
     case DECODE : 
     
     tIR=IR.read();
	
      switch(tIR.range(31,26).to_uint()) {
        case 0 : stato.write(EX_R);
                break;
        case 1 : stato.write(EX_IMM);
                break;
        case 16 : stato.write(EX_BRANCH);
                break;
        case 32 : stato.write(EX_LW);
		  
                break;
        case 40 : stato.write(EX_SW);
                break;
        default: stato.write(FETCH); 
    }
      
        break;
  case EX_R : stato.write(WB_R);
        break;
  case EX_IMM: stato.write(WB_IMM);
        break;
  case EX_LW : stato.write(MM_LW);
        break;
  case MM_LW : stato.write(WB_LW);
        break;
  case WB_LW : stato.write(FETCH);
       break;
  case EX_SW : stato.write(MM_SW);
        break;
 
  default: stato.write(FETCH);
  }
  
  wait();
 }
 }

  void dlx_seq_stati::proc_seq() {
	  sc_lv<32> tIR;
	  int a;
	  if(rst.read()){
		  for(int i=0;i<32;i++)
				RegFile[i]="00000000000000000000000000000000";
		PC.write(0);
	 }
	  else
	  switch(stato.read()) {
 
     case FETCH: 
	 addr.write(PC.read());
         MemRead.write(true);
         MemWrite.write(false);
         PC.write((PC.read()+1)%32);
		 
         break;
     case DECODE: 
          tIR=datain.read();
		  
		  IR.write(tIR);
		  irr.write(tIR);
		  iop.write(tIR.range(31,26).to_uint());
          Target.write(PC.read()+tIR.range(15,0).to_int());
          A.write(RegFile[tIR.range(25,21).to_uint()]);
          B.write(RegFile[tIR.range(20,16).to_uint()]);
          Imm.write(tIR.range(15,0).to_int());
          MemRead.write(false);
		  
          break;
     case EX_R:   
	  Ris.write(A.read().to_int()+B.read().to_int());
          break;
     case EX_IMM: 
	  Ris.write(A.read().to_int()+Imm.read());
          break;
     case EX_LW:  
	  Ris.write(A.read().to_int()+Imm.read());
          break;
     case EX_SW:  
	  Ris.write(A.read().to_int()+Imm.read());
	  break;
     case EX_BRANCH: 
	  if (A.read().to_int()==0) 
                       PC.write(Target.read()%32);
          break;
     case WB_R: 
	  RegFile[tIR.range(15,11).to_uint()]=Ris.read();
          break;
     case WB_IMM: 
	  RegFile[tIR.range(15,11).to_uint()]=Ris.read();
          break;
     case MM_LW: 
	  addr.write((Ris.read().to_int())%64);
          MemRead.write(true);
          DR=datain.read();
          break;
     case WB_LW:  
          RegFile[tIR.range(20,16).to_uint()]=DR;
          MemRead.write(false);
          break;
     case MM_SW:  
	  addr.write((Ris.read().to_int())%64);
          dataout.write(B.read());
          MemWrite.write(true);
          break;
    default:;    
   }
   
   st.write((sc_uint<4>) stato);
   
}
