#include "systemc.h"
#include "cuthread.h"
#include "tbcu.h"

int sc_main(int, char *arg[]) {
	sc_signal<bool> rst;
	sc_signal<sc_lv<6> > istr;
	sc_signal<bool> memread,memwrite;
	sc_signal<bool> Awrite,ALUwrite;
	sc_signal<bool> Regwrite;

	sc_clock clk("Clock", 10,SC_NS);

	cuthread cu("CU");
	cu(rst,clk,istr,memread,memwrite,Awrite,ALUwrite,Regwrite);

	tbcu tb("TB");
	tb(clk,rst,istr);

	sc_trace_file *tf=sc_create_vcd_trace_file("control");
    sc_trace(tf,clk,"CLK");
	sc_trace(tf,rst,"RST");
	sc_trace(tf,istr,"istr");
	sc_trace(tf,memread,"MemRead");
	sc_trace(tf,memwrite,"MemWrite");
	sc_trace(tf,Awrite,"AWrite");
	sc_trace(tf,ALUwrite,"ALUWrite");
	sc_trace(tf,Regwrite,"RegWrite");

	sc_start(sc_time(600,SC_NS));
	sc_close_vcd_trace_file(tf);

 return 0;
}