#include <systemc.h>

#include "control_unit.h"
#include "tb_cu.h"

int sc_main(int i, char *v[]) {

 sc_signal<bool> rst;
 sc_signal<int> opcode;
 sc_signal<bool> MemRead;
 sc_signal<bool> MemWrite;
 sc_signal<bool> AWrite;
 sc_signal<bool> AluWrite;
 sc_signal<bool> RegWrite;
 
 sc_signal<int> state;
 

 sc_clock clk("Clock", sc_time(10,SC_NS), 0.5, SC_ZERO_TIME,false);

 control_unit cu("CU");
 cu(clk,rst,opcode,MemRead,MemWrite,AWrite,AluWrite, RegWrite,state);
 
 tb_cu tb("TBCU");
 tb(clk,rst,opcode);

 sc_trace_file *tf=sc_create_vcd_trace_file("control");
 sc_trace(tf,clk,"CLK");
 sc_trace(tf,rst,"RST");
 sc_trace(tf,opcode,"opcode");
 sc_trace(tf,state,"stato");
 sc_trace(tf,MemRead,"MemRead");
 sc_trace(tf,MemWrite,"MemWrite");
 sc_trace(tf,AWrite,"AWrite");
 sc_trace(tf,AluWrite,"AluWrite");
 sc_trace(tf,RegWrite,"RegWrite");

 sc_start(sc_time(200,SC_NS));
 sc_close_vcd_trace_file(tf);

 return 0;
}

