#include <systemc.h>

#include "dlx_seq_stati.h"
#include "memoria.h"
#include "tb_dlx.h"

int sc_main(int q, char *arg[]) {

sc_clock clk("Clock",10,SC_NS,0.5);
 sc_signal<bool> rst;
 sc_signal<sc_lv<32> > datain;
 sc_signal<bool> MemRead;
 sc_signal<bool> MemWrite;
 sc_signal<unsigned> addr;
 sc_signal<sc_lv<32> > dataout;
 sc_signal<sc_lv<32> > irr;
 sc_signal<sc_uint<4> > st;
 sc_signal<sc_uint<6> > iop;

 dlx_seq_stati dlx("DLX");
 dlx(clk,rst,datain,MemRead,MemWrite,addr,dataout,irr,st,iop);

 memoria mm("Mem");
 mm(addr,MemRead,MemWrite,dataout,datain);
 
 tb_dlx tbd("TB");
 tbd(clk,rst);

 sc_trace_file *tf=sc_create_vcd_trace_file("dlx_stati");
 sc_trace(tf,clk,"CLK");
 sc_trace(tf,rst,"RST");
 sc_trace(tf,MemRead,"MemRead");
 sc_trace(tf,MemWrite,"MemWrite");
 sc_trace(tf,datain,"Datain");
 sc_trace(tf,addr,"Addr");
 sc_trace(tf,irr,"IR");
 sc_trace(tf,st,"Stato");
 sc_trace(tf,iop,"OP");


 sc_start(sc_time(1000,SC_NS));
 sc_close_vcd_trace_file(tf);

 return 0;
}
